FYP_WICC/accounts/api/urls.py
from email.mime import base
from django.urls import path, include 
 
from rest_framework.authtoken import views as token_views
from rest_framework.routers import DefaultRouter

from . import views     

app_name = 'accounts_api'

# router = DefaultRouter()
# router.register('users', views.CustomUserModelViewSets, basename='users')
 

urlpatterns = [  
    path('users/', views.CustomUserAPIView.as_view()),
    path('users/<int:pk>/', views.CustomUserAPIView.as_view()),
    path('users/my-details/', views.MyAccountView.as_view()),
    path('users/forget-password/', views.ForgetPasswordView.as_view()),
    path('users/forget-password/<token>/', views.ResetPasswordView.as_view(), name='reset-password' ),

    # path('get-my-token/', token_views.obtain_auth_token),
    path('login/', token_views.obtain_auth_token),
    path('users/add-certificate/', views.AddCertificateAPIView.as_view()),

] 
# + router.urls

FYP_WICC/accounts/urls.py
from django.urls import path 

from accounts.views import dashboard_views, views
 

app_name = 'accounts'

urlpatterns = [ 

    path('profile/', views.ProfileDetailView.as_view(), name='profile'),
    path('signup/', views.SignupView.as_view(), name='signup'),
    path('otp-verify/', views.OTPverify.as_view(), name='otp-verify'),
    path('login/', views.LoginFormView.as_view(), name='login'),
    path('logout/', views.UserLogoutView.as_view(), name='logout'),
    path('forget-password/', views.ForgotPasswordView.as_view(), name='forget-password' ),
    path('reset-password/<token>/', views.ResetPasswordView.as_view(), name='reset-password'),
    path('update-profile/<int:pk>/', views.UserUpdateView.as_view(), name='update-profile'),

    #payment
    path('verify-payment/', views.VerifyPaymentView.as_view(), name='verify-payment'),

    path('my-certificate/', views.MyCertificateView.as_view(), name='my_certificate'),
    path('add-owner-certificate/', views.AddCertificateView.as_view(), name='add_owner_certificate'),

    path('my-reservations/', views.MyReservationsView.as_view(), name='reservations'),
    path('<int:pk>/my-reservation-details/', views.ReservationDetailView.as_view(), name='reservation_details'),
    path('<int:pk>/cancel-reservation/', views.CancelReservationView.as_view(), name='reservation_cancel'),
    
    path('myhotel/my-hotel-detail/', views.MyHotelDetailView.as_view(), name='my_hotel_detail'),
    path('myhotel/reservation-dashboard/', views.HotelReservationDashboardView.as_view(), name='myhotel_reservation'),
    path('myhotel/filter-reservations/', views.ReservationFilterByOwnerView.as_view(), name='myhotel_filter_reservations'),
    path('myhotel/<int:pk>/customer-reservation-detail/', views.CustomerReservationDetailView.as_view(), name='customer_reservation_detail'),
    path('myhotel/<int:pk>/update-customer-reservation/', views.UpdateCustomerReservationView.as_view(), name='update_customer_reservation'),

    path('dashboard/', dashboard_views.DashboardView.as_view(), name='dashboard'),
    path('dashboard/group-filter/', dashboard_views.GroupUserFilterView.as_view(), name='group_filter'),
    path('dashboard/all-reservations/', dashboard_views.AllReservationView.as_view(), name='all_reservations' ),
    path('dashboard/reservation-hotel-filter/', dashboard_views.ReservationHotelFilterView.as_view(), name='reservation_hotel_filter'),
    path('dashboard/all-hotels/', dashboard_views.AllHotelsView.as_view(), name='all_hotels'),
    path('dashboard/<int:pk>/user-detail/', dashboard_views.DashboardUserDetail.as_view(), name='dashboard_user_detail'),
    path('dashboard/<int:pk>/verify-account/', dashboard_views.VerifyOwnerAccountView.as_view(), name='verify_account'),  

]

FYP_WICC/hbmsProject/urls.py
from django.contrib import admin
from django.urls import path, include 
from django.conf import settings 
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),

    path('', include('hotels.urls', namespace='hotels')),
    path('accounts/', include('accounts.urls', namespace='accounts')),
    path('stats/', include('stats.urls', namespace='stats')),

    path('api/hotels/', include('hotels.api.urls', namespace='hotels-api')),
    path('api/accounts/', include('accounts.api.urls', namespace='accounts-api')),
    
    
    
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT) + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

# if settings.DEBUG:
#     import debug_toolbar
#     urlpatterns +=  path('__debug__/', include('debug_toolbar.urls')), 
 

FYP_WICC/hotels/urls.py
from django.urls import path 

from . import views 

app_name = 'hotels'

urlpatterns = [ 
    path('', views.HotelListView.as_view(), name='hotel_list'),
    path('sort-hotel/', views.HotelSortView.as_view(), name='hotel_sort' ),
    # path('address/', views.HotelAddressSelectView.as_view(), name='hotel_address' ), 
    path('search/', views.HotelSearchView.as_view(), name='hotel_search'),

    path('add-hotel/', views.HotelCreateView.as_view(), name='hotel_create'),
    path('<int:pk>/detail/', views.HotelDetailView.as_view(), name='hotel_detail'),
    path('<int:pk>/update/', views.HotelUpdateView.as_view(), name='hotel_update'),
    path('<int:pk>/delete/', views.HotelDeleteView.as_view(), name='hotel_delete'),
    path('<int:pk>/comment/', views.HotelCommentView.as_view(), name='hotel_comment'),
    
    path('<int:pk>/reserve/', views.ReserveHotelView.as_view(), name='hotel_reserve'),
    

]

FYP_WICC/stats/urls.py
from django.urls import path 

from stats import views 

app_name = 'stats'

urlpatterns = [ 
    path('', views.HotelOwnerReportView.as_view(), name='report'),
    path('dashboard/reservation-report/', views.DashboardReservationReportView.as_view(), name='dashboard_reservation_report'),

    path('report/one-day-reservation/', views.pdfReportReservation, name='one_day_reservation_report'),
    path('report/reservation-date-pdf/', views.PdfReportReservationView2.as_view(), name='reservation_date_pdf'),
    

]

FYP_WICC/accounts/models.py
from email.policy import default
from django.db import models
from django.contrib.auth.models import AbstractUser 
from django.conf import settings

# Create your models here.

USER_TYPE = (
    ('customer', 'Customer/Guest'),
    ('hotel_owner', 'Hotel Owner')
)

class CustomUser(AbstractUser):

    email = models.EmailField(unique=True)
    address = models.CharField(max_length=100, blank=False, null=False)
    phone = models.CharField(max_length=10, blank=False, null=False)
    user_type = models.CharField(max_length=15, blank=False, null=False, choices=USER_TYPE, default='customer')
    verified = models.BooleanField(default=False)
    forget_password_token = models.CharField(max_length=254, null=True, blank=True)

    # otp
    otp_verified = models.BooleanField(default=False)
    counter =  models.PositiveIntegerField(default=0)

    class Meta:
        verbose_name = "Custom User"
        verbose_name_plural = "Custom Users"

    def get_user_type(self):
        return self.user_type
        # return USER_TYPE[int(self.user_type)][1]
    
    @property
    def is_hotelOwner(self): 
        return self.groups.filter(name='hotelOwner-gang').exists() 

class Certificate(models.Model):
    user = models.OneToOneField(settings.AUTH_USER_MODEL, primary_key=True, on_delete=models.CASCADE)
    image = models.ImageField(upload_to='certificate', null=False, blank=False) 

    

FYP_WICC/accounts/api/views.py
# from django.http import JsonResponse 
from hashlib import new
from django.db import IntegrityError
from django.http import JsonResponse 
from rest_framework.response import Response 
from rest_framework import viewsets, status
from rest_framework.views import APIView
# from rest_framework.authtoken.models import Token
# from rest_framework.authtoken.views import ObtainAuthToken
from rest_framework.permissions import IsAuthenticated 
from rest_framework.parsers import FormParser, MultiPartParser 

from django.contrib.auth import get_user_model
from django.contrib.auth.models import Group
from django.shortcuts import get_object_or_404
from django.db import transaction
from django.core.mail import send_mail 
from django.contrib.sites.shortcuts import get_current_site 
from django.conf import settings
from django.urls import reverse 

import uuid

from .serializer import (
    PasswordResetSerializer,
    UserSerializer,
    UserRetrieveUpdateSerializer, 
    NormalUpdateSerializer, 
    CertificateSerializer,
    ForgetPasswordSerializer
)
from .permissions import HotelOwnerMemberOnly
from accounts.models import Certificate

CustomUser = get_user_model()

# class CustomUserModelViewSets(viewsets.ModelViewSet):
#     serializer_class = UserSerializer
#     queryset = CustomUser.objects.all()
#     permission_classes = [IsAuthenticated]


class CustomUserAPIView(APIView):

    def get(self, request, pk=None, format=None):
        param_data = request.query_params  
        # print( Group.objects.get(name__iexact='customer-gang').user_set.all() )a
        id = pk 
        if id is not None: 
            if id==self.request.user.id or request.user.groups.filter(name__in=['admin-gang']).exists(): 
                user_obj = get_object_or_404(CustomUser, id=id)
                serializer = UserRetrieveUpdateSerializer(user_obj)
                return Response(serializer.data, status=status.HTTP_200_OK)
            return Response({"message": "Your're not allowed to view other user's data."}, status=status.HTTP_403_FORBIDDEN)

        elif request.user.groups.filter(name__in=['admin-gang']).exists():
            if param_data:
                try:
                    group_filter = param_data.get('group').strip()
                    if group_filter: 
                        users = Group.objects.get(name__iexact=group_filter).user_set.all().order_by('-id')
                    else:
                        users = CustomUser.objects.select_related('certificate').all().order_by('-id')
                except Exception as e:
                    return Response({"error": e.__str__(), "message": f"{group_filter} group doesn't exist"}, status=status.HTTP_400_BAD_REQUEST)
            else:
                users = CustomUser.objects.select_related('certificate').all().order_by('-id')
            
            serializers = UserRetrieveUpdateSerializer(users, many=True)
            return Response({"message":"Users data fetched successfully","count": len(users), "data": serializers.data}, status=status.HTTP_200_OK)
        
        return Response({'message': 'Not allowed'}, status=status.HTTP_405_METHOD_NOT_ALLOWED)

    def post(self, request, format=None): 
        if request.user.is_authenticated:
            return Response({'message': 'You need to be logged out before creating new user account.'})
        else:
            serializer = UserSerializer(data=request.data)
            if serializer.is_valid(): 
                serializer.save()
                # user = CustomUser.objects.get(username = serializer.data['username'])
                    # token_obj, _= Token.objects.get_or_create(user = user) 
                # return Response({'token': str(token_obj)}, status=200)
                return Response({'message': 'Account is created successfully'}, status=200)
            return Response({'errors': serializer.errors}, status=403)
    

    def put(self, request,pk, format=None):  

        obj = get_object_or_404(CustomUser,id = pk)
        if request.user.groups.filter(name__in=['admin-gang']).exists():
            serialized = UserRetrieveUpdateSerializer(instance=obj, data=request.data, partial=True)
            if serialized.is_valid():
                serialized.save()
                return Response({'message': 'update success', 'updated_data': serialized.data}, status=status.HTTP_200_OK)
            return Response({'errors': serialized.errors}, status=status.HTTP_400_BAD_REQUEST)
        else:
            if obj == request.user:
                serialized = NormalUpdateSerializer(instance=obj, data=request.data, partial=True)
                if serialized.is_valid():
                    serialized.save()
                    return Response({'message': 'udpate success', 'updated_data': serialized.data}, status=status.HTTP_200_OK)
                return Response({'errors': serialized.errors}, status=status.HTTP_400_BAD_REQUEST)
            else:
                return Response({'message': "Sorry, you're not allowed to perform this action."}, status=status.HTTP_401_UNAUTHORIZED)

""" Password Reset """
def send_password_reset_mail(email,protocol, domain, token):
    link = protocol+"://"+ domain + reverse('accounts_api:reset-password', kwargs={'token': token})
    print(link)
    subject = "Your password reset link of YOYO's account" 
    message = f"Hello sir/maa'm, click on the link to reset your password {link}"
    
    send_mail(
        subject,
        message,
        settings.EMAIL_HOST_USER,
        [email,],
        fail_silently=False,
    )

class ForgetPasswordView(APIView):

    def post(self, request, format=None):
        serialized = ForgetPasswordSerializer(data=request.data)
        if serialized.is_valid():
            email = serialized.validated_data.get('email')
            user = CustomUser.objects.filter(email__iexact=email)
            if user.exists():
                user_obj = user.first()
                token = str(uuid.uuid4())
                user_obj.forget_password_token = token 
                user_obj.save()
                current_site = get_current_site(request)
                domain = current_site.domain
                protocol = "http"
                send_password_reset_mail(user_obj.email, protocol, domain, token)
                return JsonResponse({'message': 'Password reset link is sent through mail. Check your password reset mail.'}, status=status.HTTP_200_OK)
            else:
                return JsonResponse({'message': 'User does not exist with this email.'})
        return JsonResponse({'errors': serialized.errors}, status=status.HTTP_400_BAD_REQUEST)        


class ResetPasswordView(APIView):

    def post(self, request, token, format=None):
        user = CustomUser.objects.filter(forget_password_token = token).first()
        print(token)
        print(user)
        if user:
            serialized = PasswordResetSerializer(data = request.data)
            if serialized.is_valid():
                new_password = serialized.validated_data.get('password') 
                user.set_password(new_password)
                user.forget_password_token = None 
                user.save()  
                return JsonResponse({'message': 'Password reset success'}, status=status.HTTP_200_OK)
                
            return JsonResponse({'errors': serialized.errors}, status=status.HTTP_400_BAD_REQUEST)
        else:
            return JsonResponse({'error': 'Invalid token'}, status=status.HTTP_401_UNAUTHORIZED)

class MyAccountView(APIView):
    permission_classes = [IsAuthenticated, ]

    def get(self, request, format=None):
        serialized = UserRetrieveUpdateSerializer(request.user) 
        return Response({'data': serialized.data}, status = status.HTTP_200_OK)


class AddCertificateAPIView(APIView):
    permission_classes = [IsAuthenticated, HotelOwnerMemberOnly,]
    parser_classes = [FormParser, MultiPartParser]

    def post(self, request, *args, **kwargs): 
        # print(request.data.pop('image'))
        serialized = CertificateSerializer(data=request.data, context={'request': request}) 

        # print(request.data, serialized.is_valid())
        if serialized.is_valid(): 
            pass  
            
            ''' method 1 '''
            # obj = Certificate(user=request.user,image=request.data.get('image') ) 
            # obj.save()

            ''' method 2'''
            # serialized.save(user = request.user)
    
            try:
                ''' method 3'''
                serialized.save()
            except IntegrityError as e:
                # print(e.__str__()) 
                return Response({'message': 'You have already uploaded certificate','error': e.__str__()}, status=status.HTTP_403_FORBIDDEN )
            return Response({'message' : 'Certificate added successfully', 'data': serialized.data}, status=status.HTTP_201_CREATED)
        return Response({'errors': serialized.errors}, status=status.HTTP_400_BAD_REQUEST )

FYP_WICC/templates/accounts/login.html
{% extends 'base.html' %}

{% block title %}Login{% endblock %}

{% block content %}

<div class="row mt-3">

    <div class="col-4 mx-auto">
        <p style="font-family: 'Brush Script MT', cursive; font-size:35px;" class="my-3">Login</p>
        
        {% if messages %} 
            {% for message in messages %}
                <p class="alert alert-{% if message.tags %}{{message.tags}}{% else %}info{% endif %}">{{ message }}</p>
            {% endfor %}
        {% endif %}
        
        <form method="post" novalidate> 

            {% if form.non_field_errors %}
                {% for err in form.non_field_errors %}
                    <p class="alert alert-danger">{{ err }}</p>
                {% endfor %}
            {% endif %}

            {% csrf_token %}
            {% for field in form %}
               <p> {{ field.label_tag }} {{ field}} <span style="color:red;">{{ field.errors|striptags }}</span></p>
            {% endfor %}
            <input type="submit" value="Login" class="btn btn-success" style="padding-left:30px; padding-right:30px;">
        </form>
        <p class="mt-3">Do not have an account? <a href="{% url 'accounts:signup' %}" style="text-decoration:none;">signup here</a></p>
        <p class="mt-2"><a href="{% url 'accounts:forget-password' %}" style="text-decoration:none;">Forgot password?</a></p>
    </div>

</div>


{% endblock %}

FYP_WICC/templates/accounts/profile.html
{% extends 'base.html' %}
{% load static %} 

{% block title %} Profile {% endblock %}

{% block content  %}   
<div class="container-fluid">
    <div class="row">
      <nav id="sidebarMenu" class="col-md-3 col-lg-2 d-md-block bg-light sidebar collapse">
        <div class="position-sticky pt-3">
          <ul class="nav flex-column">
            <li class="nav-item">
              <a class="nav-link active" aria-current="page" href="{% url 'accounts:profile' %}">
                My Profile
              </a>
            </li>
            {% if has_certificate %}
            <li class="nav-item">
              <a class="nav-link" href="{% url 'accounts:my_certificate' %}" id="certificateLinkId"> 
                My Certificate
              </a>
            </li> 
            {% endif %}
            {% if has_hotel %}
              <li class="nav-item">
                <a class="nav-link" href="{% url 'accounts:my_hotel_detail' %}" id="myHotelLinkId"> 
                  My Hotel
                </a>
              </li>
            {% endif %}
            <li class="nav-item">
              <a class="nav-link" href="{% url 'accounts:reservations' %}" id="reservationLinkId"> 
              <span class=" position-relative">My Reservations
                <span class="position-absolute top-0 start-100 translate-middle badge rounded-pill bg-danger" style="margin-left: 8px;">
                  {{my_reservationCount}} 
                </span>
              </span>
              </a>
            </li> 

        </div>
      </nav>
  
      <main class="col-md-9 ms-sm-auto col-lg-10 px-md-4">
        <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-3 border-bottom">
          <div class="btn-toolbar mb-2 mb-md-0"> 
          </div>
        </div> 
        <div class="container" style="width: 100%;">
            {% if messages %}
                {% for message in messages %}
                    <p class="alert alert-{% if message.tags %}{{message.tags}}{%else%}info{% endif %}">{{ message }}</p>
                {% endfor %}
            {% endif %}
            <div class="row mb-3" id="dataContainerId">
                    <p style="font-family: 'Brush Script MT', cursive; font-size:35px;">My Profile</p>
                    <hr> 
                    <div class="row">
                        <div class="col-lg-5 border " style="text-align: center; padding: 30px; border-top-left-radius: 30px; border-bottom-left-radius: 30px; ">
                            <img  class="rounded-circle" src="{% if request.user.profile.image %} {{request.user.profile.image.url}} {% else %}{% static 'default_image.jpg'  %}{% endif %}" height="250px" width="250px" >
                        </div>
                        <div class="col-lg-7 border " style="padding:30px;border-bottom-right-radius: 30px; border-bottom-right-radius: 30px;">
                            <p>Username: <b>{{ request.user.username }}</b></p>
                            <p>First Name: <b>{{ request.user.first_name }}</b></p>
                            <p>Last Name: <b>{{ request.user.last_name }}</b></p>
                            <p>User Type: <b>{{ request.user.get_user_type }}</b></p>
                            <p>User Group: <b>{{ my_group }}</b></p>
                            <p>Address: <b>{{ request.user.address }}</b></p>
                            <p>Phone: <b>{{ request.user.phone }}</b></p>
                            <p>Email: <b>{{ request.user.email }}</b></p>
                            <p>Verified:
                               {% if request.user.verified %}
                                  <span class="badge rounded-pill bg-success text-light">verified</span>
                                {% else %}
                                  <span class="badge rounded-pill bg-warning text-dark">not verified</span>

                                  <!-- <span class="d-inline-block" tabindex="0" data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-content="Disabled popover">
                                    <button class="btn btn-primary" type="button" disabled>Disabled button</button>
                                  </span> -->
                                    {% if not has_certificate %}
                                      <a href="{% url 'accounts:add_owner_certificate' %}" class="btn btn-sm btn-primary mx-2" id="addOwnerCertificateId">Add Certificate</a>
                                    {% endif %}
                                {% endif %} 
                            </p>
                            <p>
                              <button id="updateButtonId" class="btn btn-info btn-sm " style="margin-right: 5px;">Update Profile</button>
                                {% if request.user.verified and request.user.is_hotelOwner %}
                                    {% if not has_hotel %}
                                        <a href="{% url 'hotels:hotel_create' %}" class="btn btn-primary btn-sm">Add Hotel</a>
                                    {% endif %}
                                {% endif %}
                            </p> 
                        </div>
                    </div>
        
            </div>
        </div>
        
      </main>
    </div>
  </div>
  
  <div class="modal fade" id="reservationModalId" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content"></div>
    </div>
  </div> 

  <div class="modal fade" id="addOwnerCertificateModalId" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content"></div>
    </div>
  </div> 

  <div class="modal fade" id="updateUserUpdateModalId" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content"></div>
    </div>
  </div> 

<script>
function closeModal(){
  $('.modal').modal('hide');
} 

//---------------user update part 
 
$('#updateButtonId').on('click',function(){
  // e.preventDefault();
  const user_id = "{{ user.id }}";
  const url = "{% url 'accounts:update-profile' 11 %}".replace(11, user_id);

  $.get(url, function(response){ 
    $('#updateUserUpdateModalId .modal-content').empty().append(response);
    $('#updateUserUpdateModalId').modal('show');
  });
})

$('.modal').on('submit', '#updateMyProfileFormId', function(e){
  e.preventDefault();
  const user_id = "{{ user.id }}";
  const url = "{% url 'accounts:update-profile' 11 %}".replace(11, user_id);
  let formData = new FormData(this);

  // for(let i of formData.entries()){
  //   console.log(i)
  // }  

  $.ajax({
    url: url,
    method: 'POST',
    data:formData,
    processData: false,
    contentType: false,

    success:function(response){
      alert("Updated successfully");
      location.reload();
    },

    error: function(response){ 
      data = JSON.parse(response['responseText']); 
				if(data['errors']){
					errors= data['errors']  
					$('small.error').remove();
					for(key in errors){  
						if ($(`[name="${key}Error"`).length){
							$(`[name="${key}Error"]`).text(errors[key]);
						}else{ 
							$(`[name="${key}"`).parent().append(`<small name="${key}Error" class="error" style="color:red">${errors[key]}</small>`);
						}
					}  
				}else{
					alert(data['data']);
				}	
			} 
  })

})


//---------------certificate  part

$('#certificateLinkId').on('click', function(e){
  e.preventDefault();
  const href = $(this).attr('href');
  
  $.get(href, function(response){
    $('#dataContainerId').empty().append(response);
  })
})

$('#addOwnerCertificateId').on('click',function(e){
  e.preventDefault();
  $.get($(this).attr('href'), function(response){ 
    $('#addOwnerCertificateModalId .modal-content').empty().append(response);
    $('#addOwnerCertificateModalId').modal('show');
  })
})

$('.modal').on('submit', '#ownerCertificateFormId', function(e){
  e.preventDefault();
  const url = "{% url 'accounts:add_owner_certificate' %}";
  let formData = new FormData(this);

  // for(let i of formData.entries()){
  //   console.log(i)
  // }  

  $.ajax({
    url: url,
    method: 'POST',
    data:formData,
    processData: false,
    contentType: false,

    success:function(response){
      alert("success");
      location.reload();
    },

    error: function(response){
      data = JSON.parse(response['responseText']); 
				if(data['errors']){
					errors= data['errors']  
					$('small.error').remove();
					for(key in errors){ 
						if ($(`[name="${key}Error"`).length){
							$(`[name="${key}Error"]`).text(errors[key]);
						}else{ 
							$(`[name="${key}"`).parent().append(`<small name="${key}Error" class="error" style="color:red">${errors[key]}</small>`);
						}
					}  
				}else{
					alert(data['data']);
				}	
			} 

  })

})

//----------------reservation part

$('#reservationLinkId').on('click', function(e){
  e.preventDefault();
  const href = $(this).attr('href');
  
  $.get(href, function(response){
    $('#dataContainerId').empty().append(response);
  })
})

$('#myHotelLinkId').on('click', function(e){
  e.preventDefault();
  const href = $(this).attr('href');
  
  $.get(href, function(response){ 
    $('#dataContainerId').empty().append(response);
  }).fail(function(){
    alert('error');
  })
  
})

$('body').on('click','#reservationDetailId',function(e){
  e.preventDefault();
  const href = $(this).attr('href');

  $.get(href, function(response){
    $('#reservationModalId .modal-content').empty().append(response);
    $('#reservationModalId').modal('show');

  });
})

$('body').on('submit','#cancelBookingId', function(e){
  e.preventDefault();
  const reservationId = $(this).attr('data-reservationId');
  let url = "{% url 'accounts:reservation_cancel' 11 %}".replace(11, reservationId); 

  if(confirm('Are your sure you want to cancel this reservation?')){

    $.post( url ,{csrfmiddlewaretoken :  $('[name="csrfmiddlewaretoken"]').val()}, function() {
      alert( "Reservation cancelled successfully." );
      closeModal();
      location.reload();
    }).fail(function() {
      alert( "error" );
    });
  }
  
})


//------- Payment

function verifyPayment(payload){
  $.ajax({
    url:"{% url 'accounts:verify-payment' %}",
    type: "POST",
    data: payload,
    dataType: 'json',
    success: function(response){
      console.log(response)
      alert(response);
      location.reload();
    },
    error: function (response){
      console.log(response)
      alert(response.responseJSON['message']);
    }
  });
}

// var btn = document.getElementById("payment-button");
$('body').on('click', '#payment-button', function (e) {
  e.preventDefault();
  const reservationid = $(this).data('reservationid'); 
  const amount = $(this).data('amount'); 
  const payment_public_key = "{{ payment_public_key }}";
  // console.log(payment_public_key);

  var config = {
            // replace the publicKey with yours
            "publicKey": payment_public_key,
            "productIdentity": reservationid,	
            "productName": "Dragon",
            "productUrl": "http://gameofthrones.wikia.com/wiki/Dragons",
            "paymentPreference": [
                "KHALTI", 
                ],
            "eventHandler": {
                onSuccess (payload) {
                    // hit merchant api for initiating verfication
                    // console.log(payload);
                    verifyPayment(payload);
                },
                onError (error) {
                    console.log(error);
                },
                onClose () {
                    console.log('widget is closing');
                }
            }
        };
  closeModal();
  var checkout = new KhaltiCheckout(config);

	// minimum transaction amount must be 10, i.e 1000 in paisa.
  console.log(amount*100)
	// checkout.show({amount: amount*100});
  checkout.show({amount:1000})
})

</script>

{% endblock %}

FYP_WICC/templates/accounts/update_profile.html
<form method="post" id="updateMyProfileFormId" novalidate >
    <div class="modal-header"> 
        <p style="font-family: 'Brush Script MT', cursive; font-size:26px; display: inline; " >Update My Profile</p>
    </div>  
    {% csrf_token %}
    
    <div class="modal-body">
    {% for f in form %}
        <div class="mb-3">
            {{f.label_tag}} {{f}}
        </div>
    {% endfor %}
    </div>

    <div class="modal-footer">
        <input type="submit" class="btn btn-success" value="Update">
        <button type="button" onclick="closeModal()" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
    </div>
</form>